Index: orxonox/trunk/importer/Makefile.am
===================================================================
--- orxonox/trunk/importer/Makefile.am	(revision 2925)
+++ orxonox/trunk/importer/Makefile.am	(revision 2931)
@@ -8,5 +8,5 @@
 importer_SOURCES=framework.cc windowHandler.cc object.cc array.cc material.cc
 
-noinst_HEADERS=windowHandler.h object.h array.h material.h
+noinst_HEADERS=framework.h windowHandler.h object.h array.h material.h
 
 
Index: orxonox/trunk/importer/Makefile.in
===================================================================
--- orxonox/trunk/importer/Makefile.in	(revision 2925)
+++ orxonox/trunk/importer/Makefile.in	(revision 2931)
@@ -152,5 +152,5 @@
 AM_LDFLAGS = "-L/usr/Mesa-6.0.1/lib  -L/usr/X11R6/lib -lXt -lX11" $(MWINDOWS)
 importer_SOURCES = framework.cc windowHandler.cc object.cc array.cc material.cc
-noinst_HEADERS = windowHandler.h object.h array.h material.h
+noinst_HEADERS = framework.h windowHandler.h object.h array.h material.h
 all: all-am
 
Index: orxonox/trunk/importer/framework.cc
===================================================================
--- orxonox/trunk/importer/framework.cc	(revision 2925)
+++ orxonox/trunk/importer/framework.cc	(revision 2931)
@@ -1,14 +1,9 @@
-#include "windowHandler.h" // Include the Whandler Basecode
-#include "object.h"
+#include "framework.h"
 
 int verbose = 1;
-WindowHandler wHandler;  // Create an instance of the whandler basecode class
-Object* obj;
-float rotator = 0.0;
-  GLfloat whiteLight[] = {1.0, 1.0, 0.0,1.0};
 
 void DrawGLScene()
 {
-  rotator +=.001;
+  rotatorP += rotatorV;
   
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
@@ -18,12 +13,6 @@
   glLoadIdentity();	
   gluPerspective(45.0f,500/375,0.1f,100.0f);
-  gluLookAt (5*sin(rotator),7.5,5*cos(rotator), 0,0,0, 0,1,0);
-  whiteLight[1] = .5+.5*sin(rotator*10);
-  whiteLight[2] = .5+.5*sin(rotator*10);
+  gluLookAt (5*sin(rotatorP),7.5,5*cos(rotatorP), 0,0,0, 0,1,0);
 
-  GLfloat lightPosition[] = {10.0*sin(rotator*10), 10, 19.0, 0.0};
-  glLightfv(GL_LIGHT0, GL_POSITION, lightPosition);
-
-  glLightfv(GL_LIGHT0, GL_DIFFUSE, whiteLight);
   obj->draw();
 
@@ -53,14 +42,27 @@
     obj = new Object();
   
+  glEnable(GL_LIGHTING);
+  glEnable(GL_DEPTH_TEST);
+
+  GLfloat whiteLight[] = {1.0, 1.0, 1.0,1.0};
+  GLfloat light0Position[] = {10.0, 10.0, 10.0, 0.0};
+  GLfloat light1Position[] = {-10.0, -7.0, -6.0, 0.0};
   GLfloat lmodelAmbient[] = {.1, .1, .1, 1.0};
+
+  glEnable(GL_LIGHT0);
+  glLightfv(GL_LIGHT0, GL_POSITION, light0Position);
   glLightfv(GL_LIGHT0, GL_DIFFUSE, whiteLight);
   glLightfv(GL_LIGHT0, GL_SPECULAR, whiteLight);
-  glEnable(GL_LIGHTING);
-  glEnable(GL_LIGHT0);
-  glEnable(GL_DEPTH_TEST);
-
+  
+  glEnable(GL_LIGHT1);
+  glLightfv(GL_LIGHT1, GL_POSITION, light1Position);
+  glLightfv(GL_LIGHT1, GL_DIFFUSE, whiteLight);
+  glLightfv(GL_LIGHT1, GL_SPECULAR, whiteLight);
+  
+  rotatorP = .0;
+  rotatorV = .0;
   // Build the font from a TGA image font.tga in the data directory
   // Hide the mouse cursor
-  SDL_ShowCursor(0);
+    SDL_ShowCursor(2);
 
   // This is the main loop for the entire program and it will run until done==TRUE
@@ -73,4 +75,23 @@
     while ( SDL_PollEvent(&event) ) {
       switch (event.type) {
+      case SDL_MOUSEMOTION:
+	if (verbose >=3)
+	  printf("Mouse motion about %d,%d Pixels to (%d,%d).\n", 
+		 event.motion.xrel, event.motion.yrel,
+		 event.motion.x, event.motion.y);
+	break;
+      case SDL_MOUSEBUTTONDOWN:
+	printf("MouseButton %d pressed at (%d,%d).\n",
+	       event.button.button, event.button.x, event.button.y);
+	rotatorV = ( 250-event.button.x) / 500.0 /100;
+	
+	break;
+      case SDL_MOUSEBUTTONUP:
+	printf("MouseButton %d released at (%d,%d).\n",
+	       event.button.button, event.button.x, event.button.y);
+
+	
+	break;
+
         // If a quit event was recieved
       case SDL_QUIT:
Index: orxonox/trunk/importer/framework.h
===================================================================
--- orxonox/trunk/importer/framework.h	(revision 2931)
+++ orxonox/trunk/importer/framework.h	(revision 2931)
@@ -0,0 +1,15 @@
+#ifndef _FRAMEWORK_H
+#define _FRAMEWORK_H
+ 
+#include "windowHandler.h" // Include the Whandler Basecode
+#include "object.h"
+
+
+float rotatorP;
+float rotatorV;
+
+WindowHandler wHandler;  // Create an instance of the whandler basecode class
+Object* obj;
+
+
+#endif /* _FRAMEWORK_H */
Index: orxonox/trunk/importer/object.cc
===================================================================
--- orxonox/trunk/importer/object.cc	(revision 2925)
+++ orxonox/trunk/importer/object.cc	(revision 2931)
@@ -295,8 +295,8 @@
     }
   objFileName = fileName;
-  char Buffer[500];
+  char Buffer[10000];
   while(!OBJ_FILE->eof())
     {
-      OBJ_FILE->getline(Buffer, 500);
+      OBJ_FILE->getline(Buffer, 10000);
       if (verbose >=4)
 	printf ("Read input line: %s\n",Buffer);
Index: orxonox/trunk/importer/windowHandler.cc
===================================================================
--- orxonox/trunk/importer/windowHandler.cc	(revision 2925)
+++ orxonox/trunk/importer/windowHandler.cc	(revision 2931)
@@ -3,15 +3,15 @@
 #include "windowHandler.h"
 #include <stdio.h>
-void WindowHandler::ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
+void WindowHandler::ReSizeGLScene(GLsizei width, GLsizei height) // Resize And Initialize The GL Window
 {
-	if (height==0)										// Prevent A Divide By Zero By
+	if (height==0)	// Prevent A Divide By Zero By
 	{
-		height=1;										// Making Height Equal One
+		height=1;// Making Height Equal One
 	}
 
-	glViewport(0,0,width,height);						// Reset The Current Viewport
+	glViewport(0,0,width,height); // Reset The Current Viewport
 
-
-	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
+	
+	glMatrixMode(GL_PROJECTION); // Select The Projection Matrix
 	glLoadIdentity();	
 
@@ -21,6 +21,6 @@
 	gluLookAt (0,0,15, 0,0,0, 0,1,0);
 
-	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
-	glLoadIdentity();									// Reset The Modelview Matrix
+	glMatrixMode(GL_MODELVIEW); // Select The Modelview Matrix
+	glLoadIdentity(); // Reset The Modelview Matrix
 
 }
@@ -29,11 +29,11 @@
 int WindowHandler::InitGL(GLvoid)										// All Setup For OpenGL Goes Here
 {
-	glEnable(GL_TEXTURE_2D);							// Enable Texture Mapping
-	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
-	glClearColor(0.00f, 0.00f, 0.00f, 0.0f);			// Black Background
-	glClearDepth(1.0f);									// Depth Buffer Setup
-	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
-	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
-	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations
+	glEnable(GL_TEXTURE_2D); // Enable Texture Mapping
+	glShadeModel(GL_SMOOTH); // Enable Smooth Shading
+	glClearColor(0.00f, 0.00f, 0.00f, 0.0f); // Black Background
+	glClearDepth(1.0f);  // Depth Buffer Setup
+	glEnable(GL_DEPTH_TEST); // Enables Depth Testing
+	glDepthFunc(GL_LEQUAL);	// The Type Of Depth Testing To Do
+	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);  // Really Nice Perspective Calculations
 
     return TRUE;
@@ -41,5 +41,5 @@
 
 
-GLvoid WindowHandler::KillGLWindow(GLvoid)								// Properly Kill The Window
+GLvoid WindowHandler::KillGLWindow(GLvoid) // Properly Kill The Window
 {
 	SDL_Quit();
@@ -68,13 +68,13 @@
 	SDL_GL_GetAttribute( SDL_GL_STENCIL_SIZE, &size);
 
-	ReSizeGLScene(width, height);						// Set Up Our Perspective GL Screen
+	ReSizeGLScene(width, height); // Set Up Our Perspective GL Screen
 
-	if (!InitGL())										// Initialize Our Newly Created GL Window
+	if (!InitGL()) // Initialize Our Newly Created GL Window
 	{
-		KillGLWindow();									// Reset The Display
-		return FALSE;									// Return FALSE
+	  KillGLWindow();  // Reset The Display
+	  return FALSE;
 	}
 
-	return TRUE;										// Success
+	return TRUE;
 }
 
Index: orxonox/trunk/importer/windowHandler.h
===================================================================
--- orxonox/trunk/importer/windowHandler.h	(revision 2925)
+++ orxonox/trunk/importer/windowHandler.h	(revision 2931)
@@ -14,4 +14,7 @@
 #include <math.h>
 
+#ifdef __WIN32__
+#include <windows.h>
+#endif /* __WIN32__ */
 
 #define TRUE 1