Index: code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/BillboardProjectile.cc
===================================================================
--- code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/BillboardProjectile.cc	(revision 2924)
+++ code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/BillboardProjectile.cc	(revision 2969)
@@ -64,4 +64,9 @@
         this->billboard_.setColour(colour);
     }
+    
+    void BillboardProjectile::setMaterial(const std::string& material)
+    {
+        this->billboard_.setMaterial(material);
+    }
 
     void BillboardProjectile::changedVisibility()
Index: code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/BillboardProjectile.h
===================================================================
--- code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/BillboardProjectile.h	(revision 2924)
+++ code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/BillboardProjectile.h	(revision 2969)
@@ -45,4 +45,5 @@
 
             virtual void setColour(const ColourValue& colour);
+            virtual void setMaterial(const std::string& material);
             virtual void changedVisibility();
 
Index: code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/CMakeLists.txt
===================================================================
--- code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/CMakeLists.txt	(revision 2924)
+++ code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/CMakeLists.txt	(revision 2969)
@@ -3,3 +3,4 @@
   ParticleProjectile.cc
   Projectile.cc
+  LightningGunProjectile.cc
 )
Index: code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/LightningGunProjectile.cc
===================================================================
--- code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/LightningGunProjectile.cc	(revision 2969)
+++ code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/LightningGunProjectile.cc	(revision 2969)
@@ -0,0 +1,67 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Joel Smely
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+#include "LightningGunProjectile.h"
+
+#include <OgreBillboardSet.h>
+
+#include "core/GameMode.h"
+#include "core/CoreIncludes.h"
+#include "objects/Scene.h"
+#include "util/Convert.h"
+
+namespace orxonox
+{
+    CreateFactory(LightningGunProjectile);
+
+    LightningGunProjectile::LightningGunProjectile(BaseObject* creator) : BillboardProjectile(creator)
+    {
+        RegisterObject(LightningGunProjectile);
+
+        this->textureIndex_ = 1;
+        this->maxTextureIndex_ = 8;
+        this->textureTimer_.setTimer(0.01, true, this, createExecutor(createFunctor(&LightningGunProjectile::changeTexture)));
+    }
+    
+    void LightningGunProjectile::setMaterial(const std::string& material)
+    {
+        this->materialBase_ = material;    
+    
+        BillboardProjectile::setMaterial(material + convertToString(this->textureIndex_));
+    }
+
+    void LightningGunProjectile::changeTexture()
+    {
+        this->textureIndex_++;
+        if (this->textureIndex_ > this->maxTextureIndex_)
+            this->textureIndex_ = 1;
+        
+        this->setMaterial(this->materialBase_);
+    }
+}
Index: code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/LightningGunProjectile.h
===================================================================
--- code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/LightningGunProjectile.h	(revision 2969)
+++ code/branches/weapons/src/orxonox/objects/weaponsystem/projectiles/LightningGunProjectile.h	(revision 2969)
@@ -0,0 +1,57 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Joel Smely
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _LightningGunProjectile_H__
+#define _LightningGunProjectile_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "tools/Timer.h"
+
+#include "BillboardProjectile.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport LightningGunProjectile : public BillboardProjectile
+    {
+        public:
+            LightningGunProjectile(BaseObject* creator);
+            virtual ~LightningGunProjectile() {}
+            
+            virtual void setMaterial(const std::string& material);
+
+        protected:
+            void changeTexture();        
+            unsigned int textureIndex_;
+            unsigned int maxTextureIndex_;
+            Timer<LightningGunProjectile> textureTimer_;
+            std::string materialBase_;
+    };
+}
+
+#endif /* _LightningGunProjectile_H__ */
Index: code/branches/weapons/src/orxonox/objects/weaponsystem/weaponmodes/CMakeLists.txt
===================================================================
--- code/branches/weapons/src/orxonox/objects/weaponsystem/weaponmodes/CMakeLists.txt	(revision 2924)
+++ code/branches/weapons/src/orxonox/objects/weaponsystem/weaponmodes/CMakeLists.txt	(revision 2969)
@@ -2,3 +2,4 @@
   FusionFire.cc
   LaserFire.cc
+  LightningGun.cc
 )
Index: code/branches/weapons/src/orxonox/objects/weaponsystem/weaponmodes/LightningGun.cc
===================================================================
--- code/branches/weapons/src/orxonox/objects/weaponsystem/weaponmodes/LightningGun.cc	(revision 2969)
+++ code/branches/weapons/src/orxonox/objects/weaponsystem/weaponmodes/LightningGun.cc	(revision 2969)
@@ -0,0 +1,76 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Joel Smely
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+#include "LightningGun.h"
+
+#include "core/CoreIncludes.h"
+
+#include "objects/worldentities/Billboard.h"
+
+#include "objects/weaponsystem/Weapon.h"
+#include "objects/weaponsystem/WeaponPack.h"
+#include "objects/weaponsystem/WeaponSystem.h"
+
+#include "objects/weaponsystem/projectiles/LightningGunProjectile.h"
+
+#include "util/Math.h"
+
+namespace orxonox
+{
+    CreateFactory(LightningGun);
+
+    LightningGun::LightningGun(BaseObject* creator) : WeaponMode(creator)
+    {
+        RegisterObject(LightningGun);
+
+        this->reloadTime_ = 1;
+        this->damage_ = 100;
+        this->speed_ = 150;
+        
+        this->setMunitionName("LaserMunition");
+    }
+    
+    LightningGun::~LightningGun()
+    {
+    }
+
+    void LightningGun::fire()
+    {
+        LightningGunProjectile* projectile = new LightningGunProjectile(this);
+        projectile->setMaterial("Flares/LightningBall_");
+        
+        projectile->setOrientation(this->getMuzzleOrientation());
+        projectile->setPosition(this->getMuzzlePosition());
+        projectile->setVelocity(this->getMuzzleDirection() * this->speed_);
+        projectile->setAcceleration(this->getMuzzleDirection() * 1000);
+
+        projectile->setOwner(this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn());
+        projectile->setDamage(this->getDamage());
+    }
+}
Index: code/branches/weapons/src/orxonox/objects/weaponsystem/weaponmodes/LightningGun.h
===================================================================
--- code/branches/weapons/src/orxonox/objects/weaponsystem/weaponmodes/LightningGun.h	(revision 2969)
+++ code/branches/weapons/src/orxonox/objects/weaponsystem/weaponmodes/LightningGun.h	(revision 2969)
@@ -0,0 +1,49 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Joel Smely
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _LightningGun_H__
+#define _LightningGun_H__
+
+#include "OrxonoxPrereqs.h"
+#include "objects/weaponsystem/WeaponMode.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport LightningGun : public WeaponMode
+    {
+        public:
+            LightningGun(BaseObject* creator);
+            virtual ~LightningGun();
+
+            virtual void fire();
+       private:
+            float speed_;
+    };
+}
+
+#endif /* _LightningGun_H__ */